/**
 * @file
 * Contains the definition of the behaviour svg_pan_zoom.
 */

(function (drupalSettings, Drupal) {

  'use strict';

  Drupal.behaviors.svgPanZoom = {
    attach: function (context) {
      var svgs = context.querySelectorAll('.js-svg-pan-zoom');
      if (svgs.length > 0) {
        for (var i = 0; i < svgs.length; ++i) {
          // Build the configuration.
          var optionsCount = drupalSettings.svgPanZoom.availableOptions.length;
          var options = {};
          const dataNames = Object.keys(drupalSettings.svgPanZoom.availableOptions);
          for (var j = 0; j < dataNames.length; ++j) {
            var dataName = dataNames[j];
            var optionName = drupalSettings.svgPanZoom.availableOptions[dataName];
            var value = svgs[i].dataset[dataName];
            if (value === 'false' || value === 'true') {
              options[optionName] = value === 'true';
            }
            else if(!isNaN(value)) {
              options[optionName] = parseFloat(value);
            }
            else {
              options[optionName] = value;
            }
          }

          // Apply the library on the svg.
          svgs[i].addEventListener('load', function () {
            svgPanZoom(this, options);
          })
        }
      }
    }
  };

})(drupalSettings, Drupal);
